## syfi 1.0.0.dfsg

=== CMakeLists.txt ===
# Top level CMakeLists.txt file for SyFi

# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

#------------------------------------------------------------------------------
# Set project name and version number

project(SYFI)

set(SYFILIB_MAJOR_VERSION "1")
set(SYFILIB_MINOR_VERSION "0")
set(SYFILIB_MICRO_VERSION "0")
set(SYFILIB_VERSION
  "${SYFILIB_MAJOR_VERSION}.${SYFILIB_MINOR_VERSION}.${SYFILIB_MICRO_VERSION}")
add_definitions(-DSYFILIB_VERSION="${SYFILIB_VERSION}")

#------------------------------------------------------------------------------
# General configuration

# Set CMake options, see `cmake --help-policy CMP000x`
if (COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0004 OLD)
endif()

# Set location of our FindFoo.cmake modules
set(CMAKE_MODULE_PATH 
  ${CMAKE_SOURCE_DIR}/cmake/modules
  ${CMAKE_MODULE_PATH})

# Make sure CMake uses the correct syfi-config.cmake for tests and demos
#set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${CMAKE_CURRENT_BINARY_DIR}/syfi)

#------------------------------------------------------------------------------
# Configurable options for how we want to build

option(BUILD_SHARED_LIBS "Build SyFi with shared libraries." ON)
option(CMAKE_USE_RELATIVE_PATHS "Use relative paths in makefiles and projects." OFF)
option(SYFI_WITH_LIBRARY_VERSION "Build with library version information." ON)
option(SYFI_ENABLE_DOCS "Enable documentation." OFF)
option(SYFI_ENABLE_TESTING "Enable testing." OFF)

#------------------------------------------------------------------------------
# Compiler flags

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug Developer MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Check for some compiler flags
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-pipe HAVE_PIPE)
if (HAVE_PIPE)
  set(SYFI_CXX_DEVELOPER_FLAGS "-pipe ${SYFI_CXX_DEVELOPER_FLAGS}")
endif()

check_cxx_compiler_flag("-Wall -Werror" HAVE_PEDANTIC)
if (HAVE_PEDANTIC)
  set(SYFI_CXX_DEVELOPER_FLAGS "-Wall -Werror ${SYFI_CXX_DEVELOPER_FLAGS}")
endif()

check_cxx_compiler_flag(-std=c++98 HAVE_STD)
if (HAVE_STD)
  set(SYFI_CXX_DEVELOPER_FLAGS "-std=c++98 ${SYFI_CXX_DEVELOPER_FLAGS}")
endif()

check_cxx_compiler_flag(-g HAVE_DEBUG)
if (HAVE_DEBUG)
  set(SYFI_CXX_DEVELOPER_FLAGS "-g ${SYFI_CXX_DEVELOPER_FLAGS}")
endif()

check_cxx_compiler_flag(-O2 HAVE_O2_OPTIMISATION)
if (HAVE_O2_OPTIMISATION)
  set(SYFI_CXX_DEVELOPER_FLAGS "-O2 ${SYFI_CXX_DEVELOPER_FLAGS}")
endif()

# Set 'Developer' build type flags
set(CMAKE_CXX_FLAGS_DEVELOPER "${SYFI_CXX_DEVELOPER_FLAGS}" CACHE STRING
  "Flags used by the compiler during development." FORCE)

# Add debug definitions
if (CMAKE_BUILD_TYPE STREQUAL "Developer" OR CMAKE_BUILD_TYPE STREQUAL "Debug")
  list(APPEND SYFI_CXX_DEFINITIONS "-DDEBUG")
endif()

#------------------------------------------------------------------------------
# Run tests to find required packages

find_package(GiNaC REQUIRED)
find_package(PythonInterp REQUIRED)
find_package(PythonLibs REQUIRED)
find_package(NumPy REQUIRED)
find_package(SWIG REQUIRED)
include(UseSWIG)

#------------------------------------------------------------------------------
# Set include directories and libs of required packages

set(SYFI_INCLUDE_DIRECTORIES
  ${GINAC_INCLUDE_DIRS}
  )

set(SYFI_TARGET_LINK_LIBRARIES
  ${GINAC_LIBRARIES}
  )

#------------------------------------------------------------------------------
# Set compiler flags and include directories

# Add compiler include directories
include_directories(
  ${SYFI_SOURCE_DIR}/syfi
  ${SYFI_BINARY_DIR}/syfi
  ${SYFI_SOURCE_DIR}/syfi/swig
  ${SYFI_BINARY_DIR}/syfi/swig
  ${SYFI_INCLUDE_DIRECTORIES}
  )

# Add CXX defintions
add_definitions(${SYFI_CXX_DEFINITIONS})

# Add flags
set(CMAKE_CXX_FLAGS
  ${CMAKE_CXX_FLAGS}
  ${SYFI_CXX_FLAGS}
  )

#------------------------------------------------------------------------------
# Set SyFi install sub-directories

set(SYFI_BIN_DIR "bin" CACHE PATH "Binary installation directory.")
set(SYFI_LIB_DIR "lib" CACHE PATH "Library installation directory.")
set(SYFI_INCLUDE_DIR "include" CACHE PATH "C/C++ header installation directory.")
set(SYFI_PKGCONFIG_DIR "lib/pkgconfig" CACHE PATH "pkg-config file installation directory.")
set(SYFI_SHARE_DIR "share/syfi" CACHE PATH "Shared data installation directory.")
set(SYFI_MAN_DIR "share/man" CACHE PATH "Manual page installation directory.")

# Extract Python version info for use to determine where to install Python files
execute_process(
  COMMAND ${PYTHON_EXECUTABLE} -c "import platform; print platform.python_version()"
  OUTPUT_VARIABLE PYTHON_VERSION
  OUTPUT_STRIP_TRAILING_WHITESPACE
  )
string(SUBSTRING "${PYTHON_VERSION}" 0 1 PYTHON_VERSION_MAJOR)
string(SUBSTRING "${PYTHON_VERSION}" 2 1 PYTHON_VERSION_MINOR)
string(SUBSTRING "${PYTHON_VERSION}" 4 1 PYTHON_VERSION_PATCH)

# We install Python files to lib/pythonX.Y/site-packages by default
set(SYFI_PYTHON_MODULE_DIR "lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages"
  CACHE PATH "Python module installation directory")
set(SYFI_PYTHON_EXT_DIR "lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages"
  CACHE PATH "Python extension module installation directory")

#------------------------------------------------------------------------------
# Installation of sfc

install(DIRECTORY ${CMAKE_SOURCE_DIR}/site-packages/sfc
  DESTINATION ${SYFI_PYTHON_MODULE_DIR}
  USE_SOURCE_PERMISSIONS
  COMPONENT RuntimeExecutables)

install(FILES ${CMAKE_SOURCE_DIR}/scripts/sfc
  DESTINATION ${SYFI_BIN_DIR}
  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE
  COMPONENT RuntimeExecutables)

#------------------------------------------------------------------------------
# Installation of SyFi manual pages

install(DIRECTORY ${SYFI_SOURCE_DIR}/doc/man/
  DESTINATION ${SYFI_MAN_DIR}
  USE_SOURCE_PERMISSIONS
  COMPONENT RuntimeExecutables)

#------------------------------------------------------------------------------
# SyFi library

# Add source directory
add_subdirectory(syfi)

#------------------------------------------------------------------------------
# Generate and install helper file syfi.conf

# FIXME: not cross-platform compatible
# Create and install syfi.conf file
configure_file(${CMAKE_SOURCE_DIR}/cmake/templates/syfi.conf.in
  ${CMAKE_BINARY_DIR}/syfi.conf @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/syfi.conf
  DESTINATION ${SYFI_SHARE_DIR}
  COMPONENT Development)

#------------------------------------------------------------------------------
# Add demos and install demo source files

# Copy demo files to build directory
file(COPY demo DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

# Add target "demo" for building the demos
add_custom_target(demo
  COMMAND ${PYTHON_EXECUTABLE} makeall.py
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/demo")

# Add target "demo_clean" for cleaning the demos
add_custom_target(demo_clean
  COMMAND ${PYTHON_EXECUTABLE} cleanall.py
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/demo")

# Install the demo source files
install(DIRECTORY demo DESTINATION ${SYFI_SHARE_DIR})

#------------------------------------------------------------------------------
# Install demo files

install(DIRECTORY demo DESTINATION ${SYFI_SHARE_DIR})

#------------------------------------------------------------------------------
# Add tests

if (SYFI_ENABLE_TESTING)
  enable_testing()
  add_subdirectory(tests)
endif()

#------------------------------------------------------------------------------
# Generate pkg-config file and install it

# Convert include dirs to -I<incdir> form
foreach(_inc_dir ${SYFI_INCLUDE_DIRECTORIES})
  set(PKG_INCLUDES "-I${_inc_dir} ${PKG_INCLUDES}")
endforeach()

# Convert compiler flags and definitions into space separated strings
string(REPLACE ";" " " PKG_CXXFLAGS "${CMAKE_CXX_FLAGS}")
string(REPLACE ";" " " PKG_DEFINITIONS "${SYFI_CXX_DEFINITIONS}")

# Convert libraries to -L<libdir> -l<lib> form
foreach(_lib ${SYFI_TARGET_LINK_LIBRARIES})
  string(REGEX REPLACE "(.?:?/[^ ]*)/lib([^ ]*)\\.(a|so|dylib|dll)" "-L\\1 -l\\2"
    _linkflags
    "${_lib}"
    )

  # Only add libraries that matches the form -L<libdir> -l<lib>
  if ("${_linkflags}" MATCHES "-L.+ -l.+")
    set(PKG_LINKFLAGS "${_linkflags} ${PKG_LINKFLAGS}")
  endif()
endforeach()

# Remove duplicated link flags
separate_arguments(PKG_LINKFLAGS)
list(REMOVE_DUPLICATES PKG_LINKFLAGS)
string(REPLACE ";" " " PKG_LINKFLAGS "${PKG_LINKFLAGS}")

# Add additional link flags
#set(PKG_LINK_FLAGS "${PKG_LINKFLAGS} ${SYFI_LINK_FLAGS}")

# Configure and install pkg-config file
configure_file(${SYFI_SOURCE_DIR}/cmake/templates/syfi.pc.in ${CMAKE_BINARY_DIR}/syfi.pc @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/syfi.pc
  DESTINATION ${SYFI_PKGCONFIG_DIR}
  COMPONENT Development
  )

#------------------------------------------------------------------------------
# Add "make uninstall" target

configure_file(
  "${CMAKE_SOURCE_DIR}/cmake/templates/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== syfi/CMakeLists.txt ===
#------------------------------------------------------------------------------
# Install header files

file(GLOB SYFI_HEADERS *.h)
file(GLOB SYFI_SOURCES *.cpp)

install(FILES ${SYFI_HEADERS}
  DESTINATION ${SYFI_INCLUDE_DIR}/SyFi
  COMPONENT Development)

#------------------------------------------------------------------------------
# Generate and install syfi_version.h

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/syfi_version.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/syfi_version.h @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/syfi_version.h
  DESTINATION ${SYFI_INCLUDE_DIR}/SyFi
  COMPONENT Development)

#------------------------------------------------------------------------------
# Build and install library

# Define libraries
add_library(syfi ${SYFI_HEADERS} ${SYFI_SOURCES})

# Append the library version information to the library target properties
if (SYFI_WITH_LIBRARY_VERSION)
  string(REPLACE "+" "" SYFI_LIBRARY_VERSION ${SYFILIB_VERSION})
  # This setting of SOVERSION assumes that any API change
  # will increment either the minor or major version number.
  set(SYFI_LIBRARY_PROPERTIES ${SYFI_LIBRARY_PROPERTIES}
    VERSION ${SYFI_LIBRARY_VERSION}
    SOVERSION ${SYFILIB_MAJOR_VERSION}.${SYFILIB_MINOR_VERSION}
  )
endif()
set_target_properties(syfi PROPERTIES ${SYFI_LIBRARY_PROPERTIES})

# Add SyFi target libraries
target_link_libraries(syfi ${SYFI_TARGET_LINK_LIBRARIES})

# Install library
install(TARGETS syfi
  RUNTIME DESTINATION ${SYFI_LIB_DIR} COMPONENT RuntimeExecutables
  LIBRARY DESTINATION ${SYFI_LIB_DIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${SYFI_LIB_DIR} COMPONENT Development
  )

#------------------------------------------------------------------------------
# SWIG

add_subdirectory(swig)

#------------------------------------------------------------------------------
# Generate CMake config file (syfi-config.cmake)

# Set library location
get_target_property(SYFI_LIBRARY_LOCATION syfi LOCATION)
get_filename_component(SYFI_LIBRARY_FILENAME ${SYFI_LIBRARY_LOCATION} NAME)
set(SYFI_LIBRARY "${CMAKE_INSTALL_PREFIX}/${SYFI_LIB_DIR}/${SYFI_LIBRARY_FILENAME}")

configure_file(${SYFI_SOURCE_DIR}/cmake/templates/syfi-config.cmake.in
  ${CMAKE_BINARY_DIR}/syfi-config.cmake @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/syfi-config.cmake
  DESTINATION ${SYFI_SHARE_DIR}/cmake
  COMPONENT Development
  )

=== tests/CMakeLists.txt ===
add_subdirectory(cpp)

# Copy files needed to run Python tests in build directory
file(COPY python DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
  FILES_MATCHING
  PATTERN "*"
  PATTERN "CMakeLists.txt" EXCLUDE)

add_subdirectory(python)

=== syfi/swig/CMakeLists.txt ===
# Set SWIG module name
set(SWIG_MODULE_NAME SyFi)

# Set SWIG flags
set(CMAKE_SWIG_FLAGS
  -module ${SWIG_MODULE_NAME}
  -shadow
  -modern
  -modernargs
  -fastdispatch
  -fvirtual
  -nosafecstrings
  -noproxydel
  -fastproxy
  -fastinit
  -fastunpack
  -fastquery
  -nobuildnone
  ${SYFI_CXX_DEFINITIONS}
  )
set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR})

# Add needed include directories
include_directories(
  ${PYTHON_INCLUDE_DIRS}
  ${NUMPY_INCLUDE_DIRS}
)

# Get all SWIG interface files
file(GLOB SYFI_SWIG_INTERFACE_FILES "*.i")

# Set GiNaC version number in SWIG source file
string(REGEX REPLACE "([^ ])..?..?" "\\1" GINACLIB_MAJOR_VERSION "${GINAC_VERSION}")
string(REGEX REPLACE ".?.([^ ])..?" "\\1" GINACLIB_MINOR_VERSION "${GINAC_VERSION}")
string(REGEX REPLACE ".?..?.([^ ])" "\\1" GINACLIB_MICRO_VERSION "${GINAC_VERSION}")
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/SyFi.i.in ${CMAKE_CURRENT_BINARY_DIR}/SyFi.i @ONLY)

# Set SWIG source file
set(SWIG_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/${SWIG_MODULE_NAME}.i)
set_source_files_properties(${SWIG_SOURCES} PROPERTIES CPLUSPLUS ON)

# Remove '-Werror' and '-Wall' flags (if present) when compiling SWIG-generated files
string(REGEX REPLACE "-Wall" " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
string(REGEX REPLACE "-Wall" " " CMAKE_CXX_FLAGS_DEVELOPER "${CMAKE_CXX_FLAGS_DEVELOPER}")
string(REGEX REPLACE "-Werror=format-security" " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
string(REGEX REPLACE "-Werror=format-security" " " CMAKE_CXX_FLAGS_DEVELOPER "${CMAKE_CXX_FLAGS_DEVELOPER}")
string(REGEX REPLACE "-Werror" " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
string(REGEX REPLACE "-Werror" " " CMAKE_CXX_FLAGS_DEVELOPER "${CMAKE_CXX_FLAGS_DEVELOPER}")

# The prevents swig being run unnecessarily
set_source_files_properties(${SWIG_SOURCES} PROPERTIES SWIG_MODULE_NAME ${SWIG_MODULE_NAME})

# Tell CMake which SWIG interface files should be checked for changes when recompile
set(SWIG_MODULE_${SWIG_MODULE_NAME}_EXTRA_DEPS
  ${SYFI_SWIG_INTERFACE_FILES}
  ${CMAKE_SOURCE_DIR}/syfi/SyFi.h
  )

swig_add_module(${SWIG_MODULE_NAME} python ${SWIG_SOURCES})
swig_link_libraries(${SWIG_MODULE_NAME} syfi ${SYFI_TARGET_LINK_LIBRARIES} ${PYTHON_LIBRARIES})

# Install Python .py files
get_target_property(SWIG_MODULE_LOCATION ${SWIG_MODULE_${SWIG_MODULE_NAME}_REAL_NAME} LOCATION)
install(FILES
  ${SWIG_MODULE_LOCATION} ${CMAKE_CURRENT_BINARY_DIR}/${SWIG_MODULE_NAME}.py
  DESTINATION ${SYFI_PYTHON_EXT_DIR}/
  COMPONENT RuntimeLibraries
  )

# Install SWIG interface files
install(FILES ${SYFI_SWIG_INTERFACE_FILES}
  DESTINATION ${SYFI_INCLUDE_DIR}/SyFi/swig
  COMPONENT Development
  )

=== tests/cpp/CMakeLists.txt ===
file(GLOB CPP_TESTS "*.cpp")

foreach (CPP_TEST_FULL_PATH ${CPP_TESTS})
  get_filename_component(CPP_TEST "${CPP_TEST_FULL_PATH}" NAME_WE)

  add_executable(${CPP_TEST} ${CPP_TEST_FULL_PATH})
  target_link_libraries(${CPP_TEST} syfi ${SYFI_TARGET_LINK_LIBRARIES})

  add_test(NAME ${CPP_TEST} COMMAND ${CPP_TEST} > ${CPP_TEST}.out)
endforeach()

# Copy references to build directory
file(GLOB CPP_TEST_REFERENCES "*.r")

foreach (CPP_TEST_REFERENCE ${CPP_TEST_REFERENCES})
  file(COPY ${CPP_TEST_REFERENCE} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
endforeach()

=== tests/python/CMakeLists.txt ===

add_test(NAME python_tests COMMAND ${PYTHON_EXECUTABLE} run_tests.py)

=== demo/BratuProblem/python/Makefile ===

default: 
	echo "do nothing" 


clean: 
	rm -r *.pvd *.vtu sfc_jit*

=== demo/Elements/cpp/CMakeLists.txt ===
# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

project(Elements)

# Get DOLFIN configuration data
find_package(dolfin)

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Compiler definitions
add_definitions(${DOLFIN_CXX_DEFINITIONS})

# Add special DOLFIN compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${DOLFIN_CXX_FLAGS}")

# Generated code is not this robust (yet)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-variable -g")

# Generated code is not this robust (yet)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-conversion -w")

# Include directories
include_directories(
  ${DOLFIN_INCLUDE_DIRS}
  ${DOLFIN_3RD_PARTY_INCLUDE_DIRS}
  ${CMAKE_CURRENT_BINARY_DIR})

# Executable
file(GLOB SOURCES ${CMAKE_SOURCE_DIR}/*.cpp)
file(GLOB GENERATED_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/generated_code/*.cpp)
add_executable(demo ${SOURCES} ${GENERATED_SOURCES})

# Target libraries
target_link_libraries(demo ${DOLFIN_LIBRARIES} ${DOLFIN_3RD_PARTY_LIBRARIES})

=== demo/Elements/cpp/Makefile ===

FLAGS=--integration-method=symbolic --debug=0
#FLAGS=--integration-method=quadrature

FORM=Elements

demo: main.cpp build/generated_code/$(FORM).h
	cd build && cmake .. && $(MAKE)

build/generated_code/$(FORM).h: $(FORM).ufl
	sfc -w1 $(FLAGS) -obuild/generated_code $(FORM).ufl

bench: $(FORM).ufl
	sfc -b1 $(FLAGS) $(FORM).ufl

view: run
	paraview --data=build/s2_2D.pvd &

run: demo
	cd build && rm -f *.pvd *.vtu && ./demo

debug: demo
	cd build && gdb ./demo

clean:
	rm -rf build

=== demo/HyperElasticity1D/cpp/CMakeLists.txt ===
# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

project(HyperElasticity1D)

# Get DOLFIN configuration data
find_package(dolfin)

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Compiler definitions
add_definitions(${DOLFIN_CXX_DEFINITIONS})

# Add special DOLFIN compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${DOLFIN_CXX_FLAGS}")

# Code generation is not this robust (yet)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-variable")

# Enable no optimization
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -O0")

# Include directories
include_directories(
  ${DOLFIN_INCLUDE_DIRS}
  ${DOLFIN_3RD_PARTY_INCLUDE_DIRS}
  ${CMAKE_CURRENT_BINARY_DIR})

# Executable
file(GLOB SOURCES ${CMAKE_SOURCE_DIR}/*.cpp)
file(GLOB GENERATED_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/generated_code/*.cpp)
add_executable(demo ${SOURCES} ${GENERATED_SOURCES})

# Target libraries
target_link_libraries(demo ${DOLFIN_LIBRARIES} ${DOLFIN_3RD_PARTY_LIBRARIES})

=== demo/HyperElasticity1D/cpp/Makefile ===

FLAGS=--integration-method=quadrature --integration-order=9 --safemode=0

FORM=HyperElasticity1D

demo: main.cpp build/generated_code/$(FORM).h
	cd build && cmake .. && $(MAKE)

build/generated_code/$(FORM).h: $(FORM).ufl
	sfc -w1 $(FLAGS) -obuild/generated_code $(FORM).ufl

generate: clean demo

bench: $(FORM).ufl
	sfc -b1 $(FLAGS) $(FORM).ufl

view: run
	paraview --data=build/u.pvd &
	#paraview --data=build/usol.pvd &
	paraview --data=build/e.pvd &

run: demo
	cd build && rm -f *.pvd *.vtu && ./demo

debug: demo
	cd build && gdb ./demo

clean:
	rm -rf build

=== demo/HyperElasticityMooneyRivlin/cpp/CMakeLists.txt ===
# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

project(HyperElasticityMooneyRivlin)

# Get DOLFIN configuration data
find_package(dolfin)

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Compiler definitions
add_definitions(${DOLFIN_CXX_DEFINITIONS})

# Add special DOLFIN compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${DOLFIN_CXX_FLAGS}")

# Code generation is not this robust (yet)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-variable")

# Enable no optimization
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -O0")

# Include directories
include_directories(
  ${DOLFIN_INCLUDE_DIRS}
  ${DOLFIN_3RD_PARTY_INCLUDE_DIRS}
  ${CMAKE_CURRENT_BINARY_DIR})

# Executable
file(GLOB SOURCES ${CMAKE_SOURCE_DIR}/*.cpp)
file(GLOB GENERATED_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/generated_code/*.cpp)
add_executable(demo ${SOURCES} ${GENERATED_SOURCES})

# Target libraries
target_link_libraries(demo ${DOLFIN_LIBRARIES} ${DOLFIN_3RD_PARTY_LIBRARIES})

=== debian/changelog ===
syfi (1.0.0.dfsg-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    - Replace swig with swig2.0 in Build-Depends and in Depends field
      for binary package libsyfi1.0-dev.
    - Require python-ufc >= 2.0.5 and python-ufl >= 1.0.0 for binary
      package sfc.
    - Require ufc >= 2.0.5 for binary package libsyfi1.0-dev.
  * Remove patches (applied upstream).
  * debian/rules: Remove TODO from DEB_INSTALL_DOCS_ALL.

 -- Johannes Ring <johannr@simula.no>  Wed, 21 Dec 2011 10:07:42 +0100

=== debian/control ===
Source: syfi
Section: devel
Priority: extra
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>, Johannes Ring <johannr@simula.no>
Build-Depends: cdbs (>= 0.4.90~),
 debhelper (>= 7),
 python-all-dev (>= 2.6.6-3~),
 cmake,
 swig2.0,
 libginac-dev,
 pkg-config,
 python-numpy
Standards-Version: 3.9.2
X-Python-Version: >= 2.5
Homepage: http://www.fenicsproject.org
DM-Upload-Allowed: yes
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/syfi/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/syfi/trunk

Package: libsyfi1.0-dev
Section: libdevel
Architecture: any
Depends: swig2.0,
 ufc (>= 2.0.5),
 python-numpy,
 libsyfi1.0 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Conflicts: libsyfi0-dev
Replaces: libsyfi0-dev
Provides: libsyfi0-dev
Suggests: python-swiginac (>= 1.5.1)
Description: Finite element method (FEM) C++ library - development files
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package contains the development files.

Package: syfi-dev
Section: libdevel
Architecture: all
Depends: libsyfi1.0-dev (>= ${source:Version}), ${misc:Depends}
Description: Empty package depending on latest SyFi development package
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package will always depend on the most recent version of libsyfiX-dev
 (X=version), so if you install it then you will get upgrades automatically.

Package: libsyfi1.0
Section: libs
Architecture: any
Conflicts: syfi
Replaces: syfi
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: syfi-doc, libsyfi1.0-dbg, python-syfi
Description: Finite element method (FEM) C++ library - shared libraries
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package contains the shared libraries.

Package: libsyfi1.0-dbg
Section: debug
Architecture: any
Depends: libsyfi1.0 (= ${binary:Version}), ${misc:Depends}
Conflicts: libsyfi0-dbg
Replaces: libsyfi0-dbg
Provides: libsyfi0-dbg
Description: Finite element method (FEM) C++ library - debugging libraries
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package contains the shared libraries with debugging symbols.

Package: python-syfi
Section: python
Architecture: any
Depends: python-numpy,
 python-swiginac,
 libsyfi1.0 (= ${binary:Version}),
 ${python:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: python-syfi0, ${python:Provides}
Suggests: syfi-doc
Conflicts: python-syfi0
Replaces: python-syfi0
Description: Finite element method (FEM) C++ library - Python bindings
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package contains the Python interface for SyFi.

Package: syfi-doc
Architecture: all
Section: doc
Depends: libsyfi1.0-dev (>= ${source:Version}),
 sfc (= ${source:Version}),
 ${misc:Depends}
Description: Finite element method (FEM) C++ library - documentation
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package contains documentation and demo programs for SyFi.

Package: sfc
Architecture: all
Depends: python-ufl (>= 1.0.0),
 python-numpy,
 python-ufc (>= 2.0.5),
 python-syfi (>= ${source:Version}),
 ${python:Depends},
 ${misc:Depends}
Conflicts: syfi-bin
Replaces: syfi-bin
Provides: syfi-bin
Description: SyFi Form Compiler
 The SyFi Form Compiler (SFC) is a form compiler from the FEniCS
 project, compiling variational forms from the Unified Form Language
 (UFL) to efficient C++ implementations of Unified Form-assembly Code
 (UFC). SFC uses symbolic expressions for finite elements from SyFi.

=== debian/rules ===
#!/usr/bin/make -f

unexport CXXFLAGS
ifneq (,$(DEB_MAINTAINER_MODE))
  # Enable stuff not policy compliant (eg. unsuitable for build daemons)
  DEB_COPYRIGHT_CHECK_STRICT = yes
endif

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/utils.mk

DEB_COMPRESS_EXCLUDE_ALL := .py .cpp .h .pdf
DEB_INSTALL_DOCS_ALL += AUTHORS README

DEB_CMAKE_EXTRA_FLAGS= \
	-D BUILD_SHARED_LIBS:BOOL=ON \
	-D CMAKE_SKIP_RPATH:BOOL=ON \
	-D CMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=OFF \
	-D SWIG_EXECUTABLE:FILEPATH=/usr/bin/swig2.0 \
	..

USCAN_DESTDIR := $(CURDIR)

PY_VERSIONS = $(shell pyversions --requested debian/control | tac -s' ')

install-stamp-%:
	cd $(DEB_BUILDDIR) && rm CMakeCache.txt && \
	  cmake -D PYTHON_EXECUTABLE:FILEPATH=/usr/bin/$* \
	    -D PYTHON_LIBRARY:FILEPATH=/usr/lib/lib$*.so \
	    -D PYTHON_INCLUDE_DIR:PATH=/usr/include/$* \
	    $(DEB_CMAKE_NORMAL_ARGS) $(DEB_CMAKE_EXTRA_FLAGS)
	make -C $(DEB_BUILDDIR) install DESTDIR=$(CURDIR)/debian/tmp
	touch $@

install/python-syfi:: $(addprefix install-stamp-, $(PY_VERSIONS))

binary-install/python-syfi::
	dh_python2 -p$(cdbs_curpkg)

binary-install/sfc::
	dh_python2 -p$(cdbs_curpkg)

clean::
	-rm -rf $(addprefix install-stamp-, $(PY_VERSIONS))

DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -n -e 's/\.dfsg.*$$//p')

get-orig-source:
	set -ex ; \
	TMPDIR=`mktemp -d $(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION).orig.XXXXXX` ; \
	uscan --force-download --check-dirname-level 0 --destdir "$$TMPDIR" --download-version $(DEB_STRIPPED_UPSTREAM_VERSION) --upstream-version $(DEB_STRIPPED_UPSTREAM_VERSION); \
	tar -C "$$TMPDIR" --strip-components 1 -xzf "$$TMPDIR"/$(DEB_SOURCE_PACKAGE)_$(DEB_STRIPPED_UPSTREAM_VERSION).orig.tar.gz ; \
	rm -rf "$$TMPDIR"/doc/papers ; \
	rm -rf "$$TMPDIR"/doc/presentations ; \
	rm -f "$$TMPDIR"/etc/tables.txt ; \
	rm -f "$$TMPDIR"/$(DEB_SOURCE_PACKAGE)*.tar.gz ; \
	mv "$$TMPDIR" $(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION).orig ; \
	GZIP=-9 tar -czf $(CURDIR)/$(DEB_SOURCE_PACKAGE)_$(DEB_UPSTREAM_VERSION).orig.tar.gz $(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION).orig ; \
	rm -rf $(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION).orig
